public class CountingSort {

	static Integer[] countingSort(Integer[] arr) {
		// Find the maximum in the array.
		// Here we would need to check that none of
		// the entries are negative or null.
		Integer u = max(arr);
		// Create the counting table.
		int[] c = new int[u + 1];
		for (int i = 0; i < arr.length; ++i) {
			++c[arr[i]];
		}
		// j iterates over the entries [0, U].
		int j = 0;
		for (int i = 0; i < arr.length; ++i) {
			// Find the next element.
			while (c[j] == 0) ++j;
			--c[j];
			arr[i] = j;
		}
		return arr;
	}
	
	static Integer max(Integer[] arr) {
		Integer mx = null;
		for (int i = 0; i < arr.length; ++i) {
			if (mx == null || arr[i] > mx) {
				mx = arr[i];
			}
		}
		return mx;
	}

	public static void main(String[] args) {
		// Integer[] arr = SortUtils.generateRandomSeq(10, 20);
		Integer[] arr = SortUtils.generateRandomPermutation(20);
		countingSort(arr);

		System.out.println(SortUtils.isSorted(arr));
		SortUtils.displayArr(arr);

		TimingUtils.computeAvg(x -> countingSort(x),
				SortUtils.generateMultipleRandomSeqs(10, 10000, 1000));
	}

}
