package sort2;

public class HeapSort {

	static void heapify(Integer[] arr) {
		for (int i = arr.length - 1; i >= 0; --i) {
			shiftDown(arr, arr.length, i + 1);
		}
	}
	
	static void shiftDown(Integer[] arr, int len, int i) {
		while (true) {
			int left = (2 * i <= len) ? arr[2 * i - 1] : Integer.MIN_VALUE;
			int right = (2 * i + 1 <= len) ? arr[2 * i] : Integer.MIN_VALUE;
			if (arr[i - 1] >= left && arr[i - 1] >= right) return;
			int swapIdx = 2 * i;
			if (arr[i - 1] <= right && right >= left) {
				++swapIdx;
			}
			swap(arr, i - 1, swapIdx - 1);
			i = swapIdx;
		}
	}

	static Integer[] heapSort(Integer[] arr, int l, int r) {
		heapify(arr);		
		for (int i = arr.length - 1; i >= 0; --i) {
			swap(arr, i, 0);
			shiftDown(arr, i, 1);
		}
		return arr;
	}
	
	static void swap(Integer[] arr, int i, int j) {
		int tmp = arr[i];
		arr[i] = arr[j];
		arr[j] = tmp;
	}

	public static void main(String[] args) {
		// Integer[] arr = SortUtils.generateRandomSeq(10, 20);
		Integer[] arr = SortUtils.generateRandomPermutation(20);
		heapSort(arr, 0, arr.length - 1);

		System.out.println(SortUtils.isSorted(arr));
		SortUtils.displayArr(arr);

		TimingUtils.computeAvg(x -> heapSort(x, 0, x.length - 1),
				SortUtils.generateMultipleRandomSeqs(10, 10000, 1000));
	}

}
