class Solution {
    static class Event implements Comparable<Event> {
        int x;
        boolean is_start;
        public Event(int x, boolean is_start) {
            this.x = x;
            this.is_start = is_start;
        }
        
        @Override
        public int compareTo(Event other) {
        	if (x == other.x) return Boolean.compare(other.is_start, is_start);
        	return Integer.compare(x, other.x);
        }
    }
    static class Interval {
    	int x, y;
    	public Interval(int x, int y) {
    		this.x = x;
    		this.y = y;
    	}
    }
    public int[][] merge(int[][] intervals) {
        ArrayList<Event> arr = new ArrayList<>();
        for (int i = 0; i < intervals.length; ++i) {
            arr.add(new Event(intervals[i][0], true));
            arr.add(new Event(intervals[i][1], false));
        }
        // It is important when we sort to place the starts before
        // the ends.
        Collections.sort(arr);
        ArrayList<Interval> ans = new ArrayList<>();
        int countCover = 0;
        int start = 0;
        for (Event ev : arr) {
        	if (ev.is_start) {
        		if (countCover == 0) {
        			start = ev.x;
        		}
        		++countCover;
        	} else {
        		--countCover;
        		if (countCover == 0) {
        			ans.add(new Interval(start, ev.x));
               // If we wanted to find the area, we would change this to
               //    area += ev.x - start
        		}
        	}
        }
        
        // Fragment for transforming to requested format.
        int[][] ansArr = new int[ans.size()][2];
        for (int i = 0; i < ans.size(); ++i) {
        	ansArr[i][0] = ans.get(i).x;
        	ansArr[i][1] = ans.get(i).y;
        }
        return ansArr;
    }
}