/* Determines if it is possible to find an interval of length
   at least len which contains all cows. */
bool F(int len){
   // lef: leftmost cow
   int lef = 0, breads_seen = 0; 
   bool found = false;
   int i;
   for (i = 0; i<n; i++){
      // We will find the number of different breads
      // if the cow interval ends at i.
      // So, remove all cows that further that len units
      // from the i-th cow. The interval becomes: [left, i]
      while(K[i].x - K[lef].x > len) {
         A[K[lef].r]--; // Decrease bread count.
         // If this was the last cow of the bread, decrease
         // the number of different cows.
         if (A[K[lef].r] == 0) breads_seen--;
         // remove the cow.
         lef++;
      }
      //  Add the i-th cow and update breads seen.
      if (A[K[i].r] == 0) breads_seen++;
      A[K[i].r]++;
      // If we have seen all breads, we are done.
      if (breads_seen == num_breads) {
         found = true; ++i;
         break;
      }
   }
   // Cleanup the counting array.
   while(i > lef) {
      --A[K[lef].r];
      ++lef;
   }
   return found;
}